#ifndef __COMPLEX_HPP
#define __COMPLEX_HPP

template <class T>
class Complex
   {
   public:
      T r,i;
      Complex(const T& = T(), const T& = T());
      Complex(const Complex<T>&);
      
      //Assignment
      Complex<T>& operator=(const Complex<T>&);
      Complex<T>& operator+=(const Complex<T>&);
      Complex<T>& operator-=(const Complex<T>&);
      Complex<T>& operator*=(const Complex<T>&);

      //Operations
      inline Complex<T>& operator +(const Complex<T>&);
      inline Complex<T>& operator -(const Complex<T>&);
      inline Complex<T>& operator *(const Complex<T>&);
      
      //Comparision
      int operator ==(const Complex<T>& z);
      int operator !=(const Complex<T>& z);

      cis(const T& theta);
   protected:

   private:

   };

template <class T>
Complex<T>::Complex(const T& real, const T& imaginary): r(real), i(imaginary) {}

template <class T>
Complex<T>::Complex(const Complex<T>& z): r(z.r), i(z.i) {}

template <class T>
Complex<T>& Complex<T>::operator=(const Complex<T>& z)
   {
   r = z.r;
   i = z.i;
   return(*this);
   }

template <class T>
Complex<T>& Complex<T>::operator+=(const Complex<T>&)
   {
   r += z.r;
   i += z.o;
   return(*this);
   }

template <class T>
Complex<T>& Complex<T>::operator+(const Complex<T>& z)
   {
   Complex<T> w;
   w.r = r + z.r;
   w.i = i + z.i;
   return(w);
   }

template <class T>
Complex<T>& Complex<T>::operator-(const Complex<T>& z)
   {
   Complex<T> w;
   w.r = r - z.r;
   w.i = i - z.i;
   return(w);
   }

template <class T>
Complex<T>& Complex<T>::operator*(const Complex<T>& z)
   {
   Complex<T> w;
   w.r = r*z.r - i*z.i;
   w.i = r*z.i + i*z.r;
   return(w);
   }

template <class T>
int Complex<T>::operator ==(const Complex<T>& z)
   {
   return(r==z.r && i==z.i);
   }
template <class T>
int Complex<T>::operator !=(const Complex<T>& z)
   {
   return(r!=z.r || i!=z.i);
   }

template <class T>
Complex<T>::cis(const T& theta)
   {
   r = cosf(theta);
   i = sinf(theta);
   }
#endif